  using System;
using System.Configuration;
using System.Runtime.InteropServices;
using System.Text;
using System.Management;
namespace FileUploader
{

    #region MyRegion
    /**/
    /// <summary>
    /// CPUϢṹ
    /// </summary>
    [StructLayout(LayoutKind.Sequential)]
    public struct CpuInfo
    {
        /**/
        /// <summary>
        /// OEM ID
        /// </summary>
        public uint dwOemId;
        /**/
        /// <summary>
        /// ҳС
        /// </summary>
        public uint dwPageSize;
        public uint lpMinimumApplicationAddress;
        public uint lpMaximumApplicationAddress;
        public uint dwActiveProcessorMask;
        /**/
        /// <summary>
        /// CPU
        /// </summary>
        public uint dwNumberOfProcessors;
        /**/
        /// <summary>
        /// CPU
        /// </summary>
        public uint dwProcessorType;
        public uint dwAllocationGranularity;
        /**/
        /// <summary>
        /// CPUȼ
        /// </summary>
        public uint dwProcessorLevel;
        public uint dwProcessorRevision;
    }
    /**/
    /// <summary>
    /// ڴϢṹ
    /// </summary>
    [StructLayout(LayoutKind.Sequential)]
    public struct MemoryInfo
    {
        /**/
        /// <summary>
        /// 
        /// </summary>
        public uint dwLength;
        /**/
        /// <summary>
        /// Ѿʹõڴ
        /// </summary>
        public uint dwMemoryLoad;
        /**/
        /// <summary>
        /// ڴС
        /// </summary>
        public uint dwTotalPhys;
        /**/
        /// <summary>
        /// ڴС
        /// </summary>
        public uint dwAvailPhys;
        /**/
        /// <summary>
        /// ļܴС
        /// </summary>
        public uint dwTotalPageFile;
        /**/
        /// <summary>
        /// ýļС
        /// </summary>
        public uint dwAvailPageFile;
        /**/
        /// <summary>
        /// ڴС
        /// </summary>
        public uint dwTotalVirtual;
        /**/
        /// <summary>
        /// ڴС
        /// </summary>
        public uint dwAvailVirtual;
    }
    /**/
    /// <summary>
    /// ϵͳʱϢṹ
    /// </summary>
    [StructLayout(LayoutKind.Sequential)]
    public struct SystemTimeInfo
    {
        /**/
        /// <summary>
        /// 
        /// </summary>
        public ushort wYear;
        /**/
        /// <summary>
        /// 
        /// </summary>
        public ushort wMonth;
        /**/
        /// <summary>
        /// 
        /// </summary>
        public ushort wDayOfWeek;
        /**/
        /// <summary>
        /// 
        /// </summary>
        public ushort wDay;
        /**/
        /// <summary>
        /// Сʱ
        /// </summary>
        public ushort wHour;
        /**/
        /// <summary>
        /// 
        /// </summary>
        public ushort wMinute;
        /**/
        /// <summary>
        /// 
        /// </summary>
        public ushort wSecond;
        /**/
        /// <summary>
        /// 
        /// </summary>
        public ushort wMilliseconds;
    }
    #endregion
    //// <summary>
    /// SystemInfo ժҪ˵
    /// </summary>
    public class SystemInfo
    {
        private const int CHAR_COUNT = 128;
        public SystemInfo()
        {

        }
        [DllImport("kernel32")]
        private static extern void GetWindowsDirectory(StringBuilder WinDir, int count);

        [DllImport("kernel32")]
        private static extern void GetSystemDirectory(StringBuilder SysDir, int count);

        [DllImport("kernel32")]
        private static extern void GetSystemInfo(ref CpuInfo cpuInfo);

        [DllImport("kernel32")]
        private static extern void GlobalMemoryStatus(ref MemoryInfo memInfo);

        [DllImport("kernel32")]
        private static extern void GetSystemTime(ref SystemTimeInfo sysInfo);

        /**/
        /// <summary>
        /// ѯCPU
        /// </summary>
        /// <returns></returns>
        public string GetCpuId()
        {
            ManagementClass mClass = new ManagementClass("Win32_Processor");
            ManagementObjectCollection moc = mClass.GetInstances();
            string cpuId = null;
            foreach (ManagementObject mo in moc)
            {
                cpuId = mo.Properties["ProcessorId"].Value.ToString();
                break;
            }
            return cpuId;
        }

        /**/
        /// <summary>
        /// ѯӲ̱
        /// </summary>
        /// <returns></returns>
        public string GetMainHardDiskId()
        {
            ManagementObjectSearcher searcher = new ManagementObjectSearcher("SELECT * FROM Win32_PhysicalMedia");
            String hardDiskID = null;
            foreach (ManagementObject mo in searcher.Get())
            {
                hardDiskID = mo["SerialNumber"].ToString().Trim();
                break;
            }
            return hardDiskID;
        }

        /**/
        /// <summary>
        /// ȡWindowsĿ¼
        /// </summary>
        /// <returns></returns>
        public string GetWinDirectory()
        {
            StringBuilder sBuilder = new StringBuilder(CHAR_COUNT);
            GetWindowsDirectory(sBuilder, CHAR_COUNT);
            return sBuilder.ToString();
        }

        /**/
        /// <summary>
        /// ȡϵͳĿ¼
        /// </summary>
        /// <returns></returns>
        public string GetSysDirectory()
        {
            StringBuilder sBuilder = new StringBuilder(CHAR_COUNT);
            GetSystemDirectory(sBuilder, CHAR_COUNT);
            return sBuilder.ToString();
        }

        /**/
        /// <summary>
        /// ȡCPUϢ
        /// </summary>
        /// <returns></returns>
        public CpuInfo GetCpuInfo()
        {
            CpuInfo cpuInfo = new CpuInfo();
            GetSystemInfo(ref cpuInfo);
            return cpuInfo;
        }

        /**/
        /// <summary>
        /// ȡϵͳڴϢ
        /// </summary>
        /// <returns></returns>
        public MemoryInfo GetMemoryInfo()
        {
            MemoryInfo memoryInfo = new MemoryInfo();
            GlobalMemoryStatus(ref memoryInfo);
            return memoryInfo;
        }

        /**/
        /// <summary>
        /// ȡϵͳʱϢ
        /// </summary>
        /// <returns></returns>
        public SystemTimeInfo GetSystemTimeInfo()
        {
            SystemTimeInfo systemTimeInfo = new SystemTimeInfo();
            GetSystemTime(ref systemTimeInfo);
            return systemTimeInfo;
        }

        /**/
        /// <summary>
        /// ȡϵͳ
        /// </summary>
        /// <returns></returns>
        public string GetOperationSystemInName()
        {
            OperatingSystem os = System.Environment.OSVersion;
            string osName = "UNKNOWN";
            switch (os.Platform)
            {
                case PlatformID.Win32Windows:
                    switch (os.Version.Minor)
                    {
                        case 0: osName = "Windows 95"; break;
                        case 10: osName = "Windows 98"; break;
                        case 90: osName = "Windows ME"; break;
                    }
                    break;
                case PlatformID.Win32NT:
                    switch (os.Version.Major)
                    {
                        case 3: osName = "Windws NT 3.51"; break;
                        case 4: osName = "Windows NT 4"; break;
                        case 5: if (os.Version.Minor == 0)
                            {
                                osName = "Windows 2000";
                            }
                            else if (os.Version.Minor == 1)
                            {
                                osName = "Windows XP";
                            }
                            else if (os.Version.Minor == 2)
                            {
                                osName = "Windows Server 2003";
                            }
                            break;
                        case 6: osName = "Longhorn"; break;
                    }
                    break;
            }
            return String.Format("{0},{1}", osName, os.Version.ToString());
        }
    }
}
 